# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ServiceFabric::V6_2_0_9
  module Models
    #
    # Defines description for restarting a deployed code package on Service
    # Fabric node.
    #
    class RestartDeployedCodePackageDescription

      include MsRestAzure

      # @return [String] The name of service manifest that specified this code
      # package.
      attr_accessor :service_manifest_name

      # @return [String] The ActivationId of a deployed service package. If
      # ServicePackageActivationMode specified at the time of creating the
      # service
      # is 'SharedProcess' (or if it is not specified, in which case it
      # defaults to 'SharedProcess'), then value of ServicePackageActivationId
      # is always an empty string.
      attr_accessor :service_package_activation_id

      # @return [String] The name of the code package defined in the service
      # manifest.
      attr_accessor :code_package_name

      # @return [String] The instance ID for currently running entry point. For
      # a code package setup entry point (if specified) runs first and after it
      # finishes main entry point is started.
      # Each time entry point executable is run, its instance ID will change.
      # If 0 is passed in as the code package instance ID, the API will restart
      # the code package with whatever instance ID it is currently running.
      # If an instance ID other than 0 is passed in, the API will restart the
      # code package only if the current Instance ID matches the passed in
      # instance ID.
      # Note, passing in the exact instance ID (not 0) in the API is safer,
      # because if ensures at most one restart of the code package.
      attr_accessor :code_package_instance_id


      #
      # Mapper for RestartDeployedCodePackageDescription class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'RestartDeployedCodePackageDescription',
          type: {
            name: 'Composite',
            class_name: 'RestartDeployedCodePackageDescription',
            model_properties: {
              service_manifest_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'ServiceManifestName',
                type: {
                  name: 'String'
                }
              },
              service_package_activation_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ServicePackageActivationId',
                type: {
                  name: 'String'
                }
              },
              code_package_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'CodePackageName',
                type: {
                  name: 'String'
                }
              },
              code_package_instance_id: {
                client_side_validation: true,
                required: true,
                serialized_name: 'CodePackageInstanceId',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
