# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ServiceFabric::V6_5_0_36
  module Models
    #
    # Represents the health chunk of the cluster.
    # Contains the cluster aggregated health state, and the cluster entities
    # that respect the input filter.
    #
    class ClusterHealthChunk

      include MsRestAzure

      # @return [HealthState] The HealthState representing the aggregated
      # health state of the cluster computed by Health Manager.
      # The health evaluation of the entity reflects all events reported on the
      # entity and its children (if any).
      # The aggregation is done by applying the desired cluster health policy
      # and the application health policies. Possible values include:
      # 'Invalid', 'Ok', 'Warning', 'Error', 'Unknown'
      attr_accessor :health_state

      # @return [NodeHealthStateChunkList] The list of node health state chunks
      # in the cluster that respect the filters in the cluster health chunk
      # query description.
      attr_accessor :node_health_state_chunks

      # @return [ApplicationHealthStateChunkList] The list of application
      # health state chunks in the cluster that respect the filters in the
      # cluster health chunk query description.
      attr_accessor :application_health_state_chunks


      #
      # Mapper for ClusterHealthChunk class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ClusterHealthChunk',
          type: {
            name: 'Composite',
            class_name: 'ClusterHealthChunk',
            model_properties: {
              health_state: {
                client_side_validation: true,
                required: false,
                serialized_name: 'HealthState',
                type: {
                  name: 'String'
                }
              },
              node_health_state_chunks: {
                client_side_validation: true,
                required: false,
                serialized_name: 'NodeHealthStateChunks',
                type: {
                  name: 'Composite',
                  class_name: 'NodeHealthStateChunkList'
                }
              },
              application_health_state_chunks: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ApplicationHealthStateChunks',
                type: {
                  name: 'Composite',
                  class_name: 'ApplicationHealthStateChunkList'
                }
              }
            }
          }
        }
      end
    end
  end
end
