# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ServiceFabric::V6_5_0_36
  module Models
    #
    # Information about service type deployed on a node, information such as
    # the status of the service type registration on a node.
    #
    class DeployedServiceTypeInfo

      include MsRestAzure

      # @return [String] Name of the service type as specified in the service
      # manifest.
      attr_accessor :service_type_name

      # @return [String] The name of the service manifest in which this service
      # type is defined.
      attr_accessor :service_manifest_name

      # @return [String] The name of the code package that registered the
      # service type.
      attr_accessor :code_package_name

      # @return [ServiceTypeRegistrationStatus] The status of the service type
      # registration on the node. Possible values include: 'Invalid',
      # 'Disabled', 'Enabled', 'Registered'
      attr_accessor :status

      # @return [String] The ActivationId of a deployed service package. If
      # ServicePackageActivationMode specified at the time of creating the
      # service
      # is 'SharedProcess' (or if it is not specified, in which case it
      # defaults to 'SharedProcess'), then value of ServicePackageActivationId
      # is always an empty string.
      attr_accessor :service_package_activation_id


      #
      # Mapper for DeployedServiceTypeInfo class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'DeployedServiceTypeInfo',
          type: {
            name: 'Composite',
            class_name: 'DeployedServiceTypeInfo',
            model_properties: {
              service_type_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ServiceTypeName',
                type: {
                  name: 'String'
                }
              },
              service_manifest_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ServiceManifestName',
                type: {
                  name: 'String'
                }
              },
              code_package_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'CodePackageName',
                type: {
                  name: 'String'
                }
              },
              status: {
                client_side_validation: true,
                required: false,
                serialized_name: 'Status',
                type: {
                  name: 'String'
                }
              },
              service_package_activation_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ServicePackageActivationId',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
