# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ServiceFabric::V6_5_0_36
  module Models
    #
    # Information describing the identities associated with this application.
    #
    class IdentityDescription

      include MsRestAzure

      # @return [String] the endpoint for the token service managing this
      # identity
      attr_accessor :token_service_endpoint

      # @return [String] the types of identities associated with this resource;
      # currently restricted to 'SystemAssigned and UserAssigned'
      attr_accessor :type

      # @return [String] the identifier of the tenant containing the
      # application's identity.
      attr_accessor :tenant_id

      # @return [String] the object identifier of the Service Principal of the
      # identity associated with this resource.
      attr_accessor :principal_id

      # @return [Hash{String => IdentityItemDescription}] represents user
      # assigned identities map.
      attr_accessor :user_assigned_identities


      #
      # Mapper for IdentityDescription class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'IdentityDescription',
          type: {
            name: 'Composite',
            class_name: 'IdentityDescription',
            model_properties: {
              token_service_endpoint: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tokenServiceEndpoint',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              tenant_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tenantId',
                type: {
                  name: 'String'
                }
              },
              principal_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'principalId',
                type: {
                  name: 'String'
                }
              },
              user_assigned_identities: {
                client_side_validation: true,
                required: false,
                serialized_name: 'userAssignedIdentities',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'IdentityItemDescriptionElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'IdentityItemDescription'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
