# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ServiceFabric::V7_0_0_42
  module Models
    #
    # Describes a Chaos event that gets generated when Chaos has decided on the
    # faults for an iteration. This Chaos event contains the details of the
    # faults as a list of strings.
    #
    class ExecutingFaultsChaosEvent < ChaosEvent

      include MsRestAzure


      def initialize
        @Kind = "ExecutingFaults"
      end

      attr_accessor :Kind

      # @return [Array<String>] List of string description of the faults that
      # Chaos decided to execute in an iteration.
      attr_accessor :faults


      #
      # Mapper for ExecutingFaultsChaosEvent class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ExecutingFaults',
          type: {
            name: 'Composite',
            class_name: 'ExecutingFaultsChaosEvent',
            model_properties: {
              time_stamp_utc: {
                client_side_validation: true,
                required: true,
                serialized_name: 'TimeStampUtc',
                type: {
                  name: 'DateTime'
                }
              },
              Kind: {
                client_side_validation: true,
                required: true,
                serialized_name: 'Kind',
                type: {
                  name: 'String'
                }
              },
              faults: {
                client_side_validation: true,
                required: false,
                serialized_name: 'Faults',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
