# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ServiceFabric::V7_0_0_42
  module Models
    #
    # Partition Reconfiguration event.
    #
    class PartitionReconfiguredEvent < PartitionEvent

      include MsRestAzure


      def initialize
        @Kind = "PartitionReconfigured"
      end

      attr_accessor :Kind

      # @return [String] The name of a Service Fabric node.
      attr_accessor :node_name

      # @return [String] Id of Node instance.
      attr_accessor :node_instance_id

      # @return [String] Type of Service.
      attr_accessor :service_type

      # @return [Integer] CcEpochDataLoss version.
      attr_accessor :cc_epoch_data_loss_version

      # @return [Integer] CcEpochConfig version.
      attr_accessor :cc_epoch_config_version

      # @return [String] Type of reconfiguration.
      attr_accessor :reconfig_type

      # @return [String] Describes reconfiguration result.
      attr_accessor :result

      # @return [Float] Duration of Phase0 in milli-seconds.
      attr_accessor :phase0duration_ms

      # @return [Float] Duration of Phase1 in milli-seconds.
      attr_accessor :phase1duration_ms

      # @return [Float] Duration of Phase2 in milli-seconds.
      attr_accessor :phase2duration_ms

      # @return [Float] Duration of Phase3 in milli-seconds.
      attr_accessor :phase3duration_ms

      # @return [Float] Duration of Phase4 in milli-seconds.
      attr_accessor :phase4duration_ms

      # @return [Float] Total duration in milli-seconds.
      attr_accessor :total_duration_ms


      #
      # Mapper for PartitionReconfiguredEvent class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'PartitionReconfigured',
          type: {
            name: 'Composite',
            class_name: 'PartitionReconfiguredEvent',
            model_properties: {
              event_instance_id: {
                client_side_validation: true,
                required: true,
                serialized_name: 'EventInstanceId',
                type: {
                  name: 'String'
                }
              },
              category: {
                client_side_validation: true,
                required: false,
                serialized_name: 'Category',
                type: {
                  name: 'String'
                }
              },
              time_stamp: {
                client_side_validation: true,
                required: true,
                serialized_name: 'TimeStamp',
                type: {
                  name: 'DateTime'
                }
              },
              has_correlated_events: {
                client_side_validation: true,
                required: false,
                serialized_name: 'HasCorrelatedEvents',
                type: {
                  name: 'Boolean'
                }
              },
              Kind: {
                client_side_validation: true,
                required: true,
                serialized_name: 'Kind',
                type: {
                  name: 'String'
                }
              },
              partition_id: {
                client_side_validation: true,
                required: true,
                serialized_name: 'PartitionId',
                type: {
                  name: 'String'
                }
              },
              node_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'NodeName',
                type: {
                  name: 'String'
                }
              },
              node_instance_id: {
                client_side_validation: true,
                required: true,
                serialized_name: 'NodeInstanceId',
                type: {
                  name: 'String'
                }
              },
              service_type: {
                client_side_validation: true,
                required: true,
                serialized_name: 'ServiceType',
                type: {
                  name: 'String'
                }
              },
              cc_epoch_data_loss_version: {
                client_side_validation: true,
                required: true,
                serialized_name: 'CcEpochDataLossVersion',
                type: {
                  name: 'Number'
                }
              },
              cc_epoch_config_version: {
                client_side_validation: true,
                required: true,
                serialized_name: 'CcEpochConfigVersion',
                type: {
                  name: 'Number'
                }
              },
              reconfig_type: {
                client_side_validation: true,
                required: true,
                serialized_name: 'ReconfigType',
                type: {
                  name: 'String'
                }
              },
              result: {
                client_side_validation: true,
                required: true,
                serialized_name: 'Result',
                type: {
                  name: 'String'
                }
              },
              phase0duration_ms: {
                client_side_validation: true,
                required: true,
                serialized_name: 'Phase0DurationMs',
                type: {
                  name: 'Double'
                }
              },
              phase1duration_ms: {
                client_side_validation: true,
                required: true,
                serialized_name: 'Phase1DurationMs',
                type: {
                  name: 'Double'
                }
              },
              phase2duration_ms: {
                client_side_validation: true,
                required: true,
                serialized_name: 'Phase2DurationMs',
                type: {
                  name: 'Double'
                }
              },
              phase3duration_ms: {
                client_side_validation: true,
                required: true,
                serialized_name: 'Phase3DurationMs',
                type: {
                  name: 'Double'
                }
              },
              phase4duration_ms: {
                client_side_validation: true,
                required: true,
                serialized_name: 'Phase4DurationMs',
                type: {
                  name: 'Double'
                }
              },
              total_duration_ms: {
                client_side_validation: true,
                required: true,
                serialized_name: 'TotalDurationMs',
                type: {
                  name: 'Double'
                }
              }
            }
          }
        }
      end
    end
  end
end
